'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _some = require('lodash/collection/some');

var _some2 = _interopRequireDefault(_some);

var _map = require('lodash/collection/map');

var _map2 = _interopRequireDefault(_map);

var _jsdocUtils = require('./../jsdocUtils');

var _jsdocUtils2 = _interopRequireDefault(_jsdocUtils);

var _iterateJsdoc = require('./../iterateJsdoc');

var _iterateJsdoc2 = _interopRequireDefault(_iterateJsdoc);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = (0, _iterateJsdoc2.default)((functionNode, jsdocNode, jsdoc, report) => {
    let functionParameterNames, jsdocParameterNames;

    functionParameterNames = (0, _map2.default)(functionNode.params, 'name');
    jsdocParameterNames = _jsdocUtils2.default.getJsdocParameterNames(jsdoc);

    (0, _some2.default)(jsdocParameterNames, (jsdocParameterName, i) => {
        let functionParameterName;

        functionParameterName = functionParameterNames[i];

        if (!functionParameterName) {
            report('Redundant JSDoc @param "' + jsdocParameterName + '".');

            return true;
        }

        if (functionParameterName !== jsdocParameterName) {
            report('Expected JSDoc @param names to be "' + functionParameterNames.join(', ') + '". Got "' + jsdocParameterNames.join(', ') + '".');

            return true;
        }
    });
});
module.exports = exports['default'];
//# sourceMappingURL=checkParamNames.js.map
