'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _includes = require('lodash/collection/includes');

var _includes2 = _interopRequireDefault(_includes);

var _forEach = require('lodash/collection/forEach');

var _forEach2 = _interopRequireDefault(_forEach);

var _iterateJsdoc = require('./../iterateJsdoc');

var _iterateJsdoc2 = _interopRequireDefault(_iterateJsdoc);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

let validTags;

validTags = ['abstract', 'access', 'alias', 'augments', 'author', 'borrows', 'callback', 'class', 'classdesc', 'constant', 'constructs', 'copyright', 'default', 'deprecated', 'description', 'enum', 'event', 'example', 'exports', 'external', 'file', 'fires', 'function', 'global', 'ignore', 'implements', 'inheritdoc', 'inner', 'instance', 'interface', 'kind', 'lends', 'license', 'listens', 'member', 'memberof', 'mixes', 'mixin', 'module', 'name', 'namespace', 'override', 'param', 'private', 'property', 'protected', 'public', 'readonly', 'requires', 'returns', 'see', 'since', 'static', 'summary', 'this', 'throws', 'todo', 'tutorial', 'type', 'typedef', 'variation', 'version'];

exports.default = (0, _iterateJsdoc2.default)((functionNode, jsdocNode, jsdoc, report) => {
    (0, _forEach2.default)(jsdoc.tags, jsdocTag => {
        if (!(0, _includes2.default)(validTags, jsdocTag.tag)) {
            report('Invalid JSDoc tag name "' + jsdocTag.tag + '".');
        }
    });
});
module.exports = exports['default'];
//# sourceMappingURL=checkTagNames.js.map
